package com.brilliance.swift.mt2mx.camt056001.impl;

import com.brilliance.swift.exception.SwiftException;
import com.brilliance.swift.mt2mx.camt029001.AbstractMt2MxCamt029001ParseField;
import com.brilliance.swift.mt2mx.camt056001.AbstractMt2MxCamt056001ParseField;
import com.prowidesoftware.swift.model.Tag;
import com.prowidesoftware.swift.model.mt.AbstractMT;

import java.util.HashMap;
import java.util.Map;

public class Camt056001Parse20Field extends AbstractMt2MxCamt056001ParseField {

    private static final String NAME = "20";

    @Override
    public void parseField() throws SwiftException {
        AbstractMT abstractMT = context.get(AbstractMT.class);
        Tag tag20 = abstractMT.getSwiftMessage().getBlock4().getTagByName(NAME);
        if (tag20 != null) {
            appHdrMaps.put("bizMsgIdr", tag20.getValue());
            assgnmtMaps.put("id",tag20.getValue());
            Map<String, Object> txInfMaps = getTxInfMaps();
            Map<String, Object> caseMaps = null;
            if(txInfMaps.containsKey("case")){
                caseMaps = (Map<String, Object>) txInfMaps.get("case");
            }else {
                caseMaps = new HashMap<>();
                txInfMaps.put("case",caseMaps);
            }
            caseMaps.put("id",tag20.getValue());
        }
    }
}
